/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Diff of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.61 Revision 1.132
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.61 2007/01/04 14:56:46 flameeyes Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.132 2012/05/20 10:32:05 vapier Exp $
4# 4
5# Author: Diego Pettenò <flameeyes@gentoo.org> 5# @ECLASS: autotools.eclass
6# Enhancements: Martin Schlemmer <azarah@gentoo.org> 6# @MAINTAINER:
7# 7# base-system@gentoo.org
8# @BLURB: Regenerates auto* build scripts
9# @DESCRIPTION:
8# This eclass is for handling autotooled software packages that 10# This eclass is for safely handling autotooled software packages that need to
9# needs to regenerate their build scripts. 11# regenerate their build scripts. All functions will abort in case of errors.
10# 12
11# NB: If you add anything, please comment it! 13# Note: We require GNU m4, as does autoconf. So feel free to use any features
14# from the GNU version of m4 without worrying about other variants (i.e. BSD).
15
16if [[ ${___ECLASS_ONCE_AUTOTOOLS} != "recur -_+^+_- spank" ]] ; then
17___ECLASS_ONCE_AUTOTOOLS="recur -_+^+_- spank"
12 18
13inherit eutils libtool 19inherit eutils libtool
20
21# @ECLASS-VARIABLE: WANT_AUTOCONF
22# @DESCRIPTION:
23# The major version of autoconf your package needs
24: ${WANT_AUTOCONF:=latest}
25
26# @ECLASS-VARIABLE: WANT_AUTOMAKE
27# @DESCRIPTION:
28# The major version of automake your package needs
29: ${WANT_AUTOMAKE:=latest}
30
31# @ECLASS-VARIABLE: WANT_LIBTOOL
32# @DESCRIPTION:
33# Do you want libtool? Valid values here are "latest" and "none".
34: ${WANT_LIBTOOL:=latest}
35
36# @ECLASS-VARIABLE: _LATEST_AUTOMAKE
37# @INTERNAL
38# @DESCRIPTION:
39# CONSTANT!
40# The latest major version/slot of automake available on each arch. #312315
41# If a newer slot is stable on any arch, and is NOT reflected in this list,
42# then circular dependencies may arise during emerge @system bootstraps.
43# Do NOT change this variable in your ebuilds!
44# If you want to force a newer minor version, you can specify the correct
45# WANT value by using a colon: <PV>[:<WANT_AUTOMAKE>]
46_LATEST_AUTOMAKE=( 1.11.1:1.11 )
14 47
15_automake_atom="sys-devel/automake" 48_automake_atom="sys-devel/automake"
16_autoconf_atom="sys-devel/autoconf" 49_autoconf_atom="sys-devel/autoconf"
17if [[ -n ${WANT_AUTOMAKE} ]]; then 50if [[ -n ${WANT_AUTOMAKE} ]]; then
18 case ${WANT_AUTOMAKE} in 51 case ${WANT_AUTOMAKE} in
19 # workaround while we have different versions of automake in arch and ~arch 52 none) _automake_atom="" ;; # some packages don't require automake at all
20 latest) _automake_atom="|| ( =sys-devel/automake-1.10* =sys-devel/automake-1.9* )" ;; 53 # if you change the "latest" version here, change also autotools_run_tool
54 # this MUST reflect the latest stable major version for each arch!
55 latest)
56 # Use SLOT deps if we can. For EAPI=0, we get pretty close.
57 if [[ ${EAPI:-0} != 0 ]] ; then
58 _automake_atom="|| ( `printf '>=sys-devel/automake-%s:%s ' ${_LATEST_AUTOMAKE[@]/:/ }` )"
59 else
60 _automake_atom="|| ( `printf '>=sys-devel/automake-%s ' ${_LATEST_AUTOMAKE[@]/%:*}` )"
61 fi
62 ;;
21 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;; 63 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
22 esac 64 esac
65 export WANT_AUTOMAKE
23fi 66fi
24 67
25if [[ -n ${WANT_AUTOCONF} ]] ; then 68if [[ -n ${WANT_AUTOCONF} ]] ; then
26 case ${WANT_AUTOCONF} in 69 case ${WANT_AUTOCONF} in
70 none) _autoconf_atom="" ;; # some packages don't require autoconf at all
27 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;; 71 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
72 # if you change the "latest" version here, change also autotools_env_setup
28 latest | 2.5) _autoconf_atom=">=sys-devel/autoconf-2.59" ;; 73 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.68" ;;
74 *) die "Invalid WANT_AUTOCONF value '${WANT_AUTOCONF}'" ;;
29 esac 75 esac
76 export WANT_AUTOCONF
30fi 77fi
31DEPEND="${_automake_atom} 78
32 ${_autoconf_atom} 79_libtool_atom="sys-devel/libtool"
33 sys-devel/libtool" 80if [[ -n ${WANT_LIBTOOL} ]] ; then
81 case ${WANT_LIBTOOL} in
82 none) _libtool_atom="" ;;
83 latest) ;;
84 *) die "Invalid WANT_LIBTOOL value '${WANT_LIBTOOL}'" ;;
85 esac
86 export WANT_LIBTOOL
87fi
88
89AUTOTOOLS_DEPEND="${_automake_atom} ${_autoconf_atom} ${_libtool_atom}"
34RDEPEND="" 90RDEPEND=""
91
92# @ECLASS-VARIABLE: AUTOTOOLS_AUTO_DEPEND
93# @DESCRIPTION:
94# Set to 'no' to disable automatically adding to DEPEND. This lets
95# ebuilds former conditional depends by using ${AUTOTOOLS_DEPEND} in
96# their own DEPEND string.
97: ${AUTOTOOLS_AUTO_DEPEND:=yes}
98if [[ ${AUTOTOOLS_AUTO_DEPEND} != "no" ]] ; then
99 DEPEND=${AUTOTOOLS_DEPEND}
100fi
101
35unset _automake_atom _autoconf_atom 102unset _automake_atom _autoconf_atom
36 103
37# Variables: 104# @ECLASS-VARIABLE: AM_OPTS
38# 105# @DEFAULT_UNSET
39# AT_M4DIR - Additional director(y|ies) aclocal should search 106# @DESCRIPTION:
40# AM_OPTS - Additional options to pass to automake during 107# Additional options to pass to automake during
41# eautoreconf call. 108# eautoreconf call.
109
110# @ECLASS-VARIABLE: AT_NOEAUTOMAKE
111# @DEFAULT_UNSET
112# @DESCRIPTION:
113# Don't run eautomake command if set to 'yes'; only used to workaround
114# broken packages. Generally you should, instead, fix the package to
115# not call AM_INIT_AUTOMAKE if it doesn't actually use automake.
116
117# @ECLASS-VARIABLE: AT_NOELIBTOOLIZE
118# @DEFAULT_UNSET
119# @DESCRIPTION:
42# AT_NOELIBTOOLIZE - Don't run elibtoolize command if set to 'yes', 120# Don't run elibtoolize command if set to 'yes',
43# useful when elibtoolize needs to be ran with 121# useful when elibtoolize needs to be ran with
44# particular options 122# particular options
45 123
46# Functions: 124# @ECLASS-VARIABLE: AT_M4DIR
47# 125# @DESCRIPTION:
48# eautoreconf() - Should do a full autoreconf - normally what most people 126# Additional director(y|ies) aclocal should search
49# will be interested in. Also should handle additional 127: ${AT_M4DIR:=}
50# directories specified by AC_CONFIG_SUBDIRS.
51# eaclocal() - Runs aclocal. Respects AT_M4DIR for additional directories
52# to search for macro's.
53# _elibtoolize() - Runs libtoolize. Note the '_' prefix .. to not collide
54# with elibtoolize() from libtool.eclass
55# eautoconf - Runs autoconf.
56# eautoheader - Runs autoheader.
57# eautomake - Runs automake
58#
59 128
60# XXX: M4DIR should be depreciated 129# @ECLASS-VARIABLE: AT_SYS_M4DIR
61AT_M4DIR=${AT_M4DIR:-${M4DIR}} 130# @INTERNAL
62AT_GNUCONF_UPDATE="no" 131# @DESCRIPTION:
132# For system integrators, a list of additional aclocal search paths.
133# This variable gets eval-ed, so you can use variables in the definition
134# that may not be valid until eautoreconf & friends are run.
135: ${AT_SYS_M4DIR:=}
63 136
64 137# @FUNCTION: eautoreconf
138# @DESCRIPTION:
65# This function mimes the behavior of autoreconf, but uses the different 139# This function mimes the behavior of autoreconf, but uses the different
66# eauto* functions to run the tools. It doesn't accept parameters, but 140# eauto* functions to run the tools. It doesn't accept parameters, but
67# the directory with include files can be specified with AT_M4DIR variable. 141# the directory with include files can be specified with AT_M4DIR variable.
142#
143# Should do a full autoreconf - normally what most people will be interested in.
144# Also should handle additional directories specified by AC_CONFIG_SUBDIRS.
68eautoreconf() { 145eautoreconf() {
69 local pwd=$(pwd) x auxdir 146 local x g
70 147
71 if [[ -z ${AT_NO_RECURSIVE} ]]; then 148 if [[ -z ${AT_NO_RECURSIVE} ]]; then
72 # Take care of subdirs 149 # Take care of subdirs
73 for x in $(autotools_get_subdirs); do 150 for x in $(autotools_get_subdirs); do
74 if [[ -d ${x} ]] ; then 151 if [[ -d ${x} ]] ; then
75 cd "${x}" 152 pushd "${x}" >/dev/null
76 AT_NOELIBTOOLIZE="yes" eautoreconf 153 AT_NOELIBTOOLIZE="yes" eautoreconf
77 cd "${pwd}" 154 popd >/dev/null
78 fi 155 fi
79 done 156 done
80 fi 157 fi
81 158
82 auxdir=$(autotools_get_auxdir) 159 local auxdir=$(autotools_get_auxdir)
160 local macdir=$(autotools_get_macrodir)
83 161
84 einfo "Running eautoreconf in '$(pwd)' ..." 162 einfo "Running eautoreconf in '${PWD}' ..."
85 [[ -n ${auxdir} ]] && mkdir -p ${auxdir} 163 [[ -n ${auxdir}${macdir} ]] && mkdir -p ${auxdir} ${macdir}
86 eaclocal 164 eaclocal
165 if grep -q '^AM_GNU_GETTEXT_VERSION' configure.?? ; then
166 eautopoint --force
167 fi
168 [[ ${CHOST} == *-darwin* ]] && g=g
169 if ${LIBTOOLIZE:-${g}libtoolize} -n --install >& /dev/null ; then
170 _elibtoolize --copy --force --install
171 else
87 _elibtoolize --copy --force 172 _elibtoolize --copy --force
173 fi
88 eautoconf 174 eautoconf
89 eautoheader 175 eautoheader
90 FROM_EAUTORECONF="yes" eautomake ${AM_OPTS} 176 [[ ${AT_NOEAUTOMAKE} != "yes" ]] && FROM_EAUTORECONF="yes" eautomake ${AM_OPTS}
91 177
92 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0 178 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0
93 179
94 # Call it here to prevent failures due to elibtoolize called _before_ 180 # Call it here to prevent failures due to elibtoolize called _before_
95 # eautoreconf. 181 # eautoreconf. We set $S because elibtoolize runs on that #265319
96 elibtoolize 182 S=${PWD} elibtoolize --force
97 183
98 return 0 184 return 0
99} 185}
100 186
187# @FUNCTION: eaclocal_amflags
188# @DESCRIPTION:
189# Extract the ACLOCAL_AMFLAGS value from the Makefile.am and try to handle
190# (most) of the crazy crap that people throw at us.
191eaclocal_amflags() {
192 local aclocal_opts amflags_file
193
194 for amflags_file in GNUmakefile.am Makefile.am GNUmakefile.in Makefile.in ; do
195 [[ -e ${amflags_file} ]] || continue
196 # setup the env in case the pkg does something crazy
197 # in their ACLOCAL_AMFLAGS. like run a shell script
198 # which turns around and runs autotools. #365401
199 # or split across multiple lines. #383525
200 autotools_env_setup
201 aclocal_opts=$(sed -n \
202 "/^ACLOCAL_AMFLAGS[[:space:]]*=/{ \
203 # match the first line
204 s:[^=]*=::p; \
205 # then gobble up all escaped lines
206 : nextline /\\\\$/{ n; p; b nextline; } \
207 }" ${amflags_file})
208 eval aclocal_opts=\""${aclocal_opts}"\"
209 break
210 done
211
212 echo ${aclocal_opts}
213}
214
215# @FUNCTION: eaclocal
216# @DESCRIPTION:
101# These functions runs the autotools using autotools_run_tool with the 217# These functions runs the autotools using autotools_run_tool with the
102# specified parametes. The name of the tool run is the same of the function 218# specified parametes. The name of the tool run is the same of the function
103# without e prefix. 219# without e prefix.
104# They also force installing the support files for safety. 220# They also force installing the support files for safety.
221# Respects AT_M4DIR for additional directories to search for macro's.
105eaclocal() { 222eaclocal() {
106 local aclocal_opts
107
108 if [[ -n ${AT_M4DIR} ]] ; then
109 for x in ${AT_M4DIR} ; do
110 case "${x}" in
111 "-I")
112 # We handle it below
113 ;;
114 *)
115 [[ ! -d ${x} ]] && ewarn "eaclocal: '${x}' does not exist"
116 aclocal_opts="${aclocal_opts} -I ${x}"
117 ;;
118 esac
119 done
120 fi
121
122 autotools_set_versions
123 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \ 223 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
124 autotools_run_tool aclocal "$@" ${aclocal_opts} 224 autotools_run_tool --at-m4flags aclocal "$@" $(eaclocal_amflags)
125} 225}
126 226
227# @FUNCTION: _elibtoolize
228# @DESCRIPTION:
229# Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from
230# libtool.eclass.
127_elibtoolize() { 231_elibtoolize() {
128 local opts 232 local opts g=
129 local lttest
130 233
131 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro, 234 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro,
132 # check for both it and the current AC_PROG_LIBTOOL) 235 # check for both it and the current AC_PROG_LIBTOOL)
133 lttest="$(autotools_check_macro "AC_PROG_LIBTOOL")$(autotools_check_macro "AM_PROG_LIBTOOL")" 236 [[ -n $(autotools_check_macro AC_PROG_LIBTOOL AM_PROG_LIBTOOL LT_INIT) ]] || return 0
134 [[ -n $lttest ]] || return 0
135 237
136 [[ -f Makefile.am ]] && opts="--automake" 238 [[ -f GNUmakefile.am || -f Makefile.am ]] && opts="--automake"
137 239
138 [[ "${USERLAND}" == "Darwin" ]] && LIBTOOLIZE="glibtoolize" 240 [[ ${CHOST} == *-darwin* ]] && g=g
139 autotools_run_tool ${LIBTOOLIZE:-libtoolize} "$@" ${opts} 241 autotools_run_tool ${LIBTOOLIZE:-${g}libtoolize} "$@" ${opts}
140 242
141 # Need to rerun aclocal 243 # Need to rerun aclocal
142 eaclocal 244 eaclocal
143} 245}
144 246
247# @FUNCTION: eautoheader
248# @DESCRIPTION:
249# Runs autoheader.
145eautoheader() { 250eautoheader() {
146 # Check if we should run autoheader 251 # Check if we should run autoheader
147 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0 252 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
148 autotools_set_versions 253 autotools_run_tool --at-no-fail --at-m4flags autoheader "$@"
149 NO_FAIL=1 autotools_run_tool autoheader "$@"
150} 254}
151 255
256# @FUNCTION: eautoconf
257# @DESCRIPTION:
258# Runs autoconf.
152eautoconf() { 259eautoconf() {
153 if [[ ! -f configure.ac && ! -f configure.in ]] ; then 260 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
154 echo 261 echo
155 eerror "No configure.{ac,in} present in '$(pwd | sed -e 's:.*/::')'!" 262 eerror "No configure.{ac,in} present in '${PWD}'!"
156 echo 263 echo
157 die "No configure.{ac,in} present!" 264 die "No configure.{ac,in} present!"
158 fi 265 fi
159 266
160 autotools_set_versions
161 autotools_run_tool autoconf "$@" 267 autotools_run_tool --at-m4flags autoconf "$@"
162} 268}
163 269
270# @FUNCTION: eautomake
271# @DESCRIPTION:
272# Runs automake.
164eautomake() { 273eautomake() {
165 local extra_opts 274 local extra_opts
275 local makefile_name
166 276
167 [[ -f Makefile.am ]] || return 0 277 # Run automake if:
278 # - a Makefile.am type file exists
279 # - the configure script is using the AM_INIT_AUTOMAKE directive
280 for makefile_name in {GNUmakefile,{M,m}akefile}.am "" ; do
281 [[ -f ${makefile_name} ]] && break
282 done
168 283
169 autotools_set_versions 284 if [[ -z ${makefile_name} ]] ; then
285 # Really we should just use autotools_check_macro ...
286 local am_init_automake=$(sed -n '/AM_INIT_AUTOMAKE/{s:#.*::;s:\<dnl\>.*::;p}' configure.??)
287 if [[ ${am_init_automake} != *"AM_INIT_AUTOMAKE"* ]] ; then
288 return 0
289 fi
290
170 if [[ -z ${FROM_EAUTORECONF} && -f Makefile.in ]]; then 291 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then
171 local used_automake 292 local used_automake
172 local installed_automake 293 local installed_automake
173 294
174 installed_automake=$(automake --version | head -n 1 | \ 295 installed_automake=$(WANT_AUTOMAKE= automake --version | head -n 1 | \
175 sed -e 's:.*(GNU automake) ::') 296 sed -e 's:.*(GNU automake) ::')
176 used_automake=$(head -n 1 < Makefile.in | \ 297 used_automake=$(head -n 1 < ${makefile_name%.am}.in | \
177 sed -e 's:.*by automake \(.*\) from .*:\1:') 298 sed -e 's:.*by automake \(.*\) from .*:\1:')
178 299
179 if [[ ${installed_automake} != ${used_automake} ]]; then 300 if [[ ${installed_automake} != ${used_automake} ]]; then
180 einfo "Automake used for the package (${used_automake}) differs from" 301 einfo "Automake used for the package (${used_automake}) differs from"
181 einfo "the installed version (${installed_automake})." 302 einfo "the installed version (${installed_automake})."
182 eautoreconf 303 eautoreconf
183 return 0 304 return 0
184 fi 305 fi
185 fi 306 fi
186 307
187 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS ]] \ 308 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS && -f README ]] \
188 || extra_opts="${extra_opts} --foreign" 309 || extra_opts="${extra_opts} --foreign"
189 310
190 # --force-missing seems not to be recognized by some flavours of automake 311 # --force-missing seems not to be recognized by some flavours of automake
191 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@" 312 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
192} 313}
193 314
194autotools_set_versions() { 315# @FUNCTION: eautopoint
195 [[ -n ${autotools_version_sets} ]] && return 0 316# @DESCRIPTION:
317# Runs autopoint (from the gettext package).
318eautopoint() {
319 autotools_run_tool autopoint "$@"
320}
196 321
197 if [[ -n ${WANT_AUTOCONF} ]]; then 322# @FUNCTION: config_rpath_update
198 [[ ${WANT_AUTOCONF} == "latest" ]] && WANT_AUTOCONF="2.5" 323# @USAGE: [destination]
199 export WANT_AUTOCONF 324# @DESCRIPTION:
200 einfo "Requested autoconf ${WANT_AUTOCONF}" 325# Some packages utilize the config.rpath helper script, but don't
201 einfo "Using $(autoconf --version 2>/dev/null | head -n 1)" 326# use gettext directly. So we have to copy it in manually since
202 einfo "Using $(autoheader --version 2>/dev/null | head -n 1)" 327# we can't let `autopoint` do it for us.
203 else 328config_rpath_update() {
204 ewarn "QA Notice: \${WANT_AUTOCONF} variable unset. Please report on http://bugs.gentoo.org/" 329 local dst src=$(type -P gettext | sed 's:bin/gettext:share/gettext/config.rpath:')
205 fi
206 330
207 if [[ -n ${WANT_AUTOMAKE} ]]; then 331 [[ $# -eq 0 ]] && set -- $(find -name config.rpath)
208 local latest_automake 332 [[ $# -eq 0 ]] && return 0
209 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then 333
210 latest_automake="latest: " 334 einfo "Updating all config.rpath files"
211 for amver in 1.10 1.9 1.8 1.7 1.6; do 335 for dst in "$@" ; do
212 WANT_AUTOMAKE="${amver}" 336 einfo " ${dst}"
213 ROOT=/ has_version =sys-devel/automake-${amver}* && break 337 cp "${src}" "${dst}" || die
214 done 338 done
215 fi
216 export WANT_AUTOMAKE
217 einfo "Requested automake ${latest_automake}${WANT_AUTOMAKE}"
218 einfo "Using $(automake --version 2>/dev/null | head -n 1)"
219 einfo "Using $(aclocal --version 2>/dev/null | head -n 1)"
220 else
221 ewarn "QA Notice: \${WANT_AUTOMAKE} variable unset. Please report on http://bugs.gentoo.org/"
222 fi
223
224 autotools_version_sets="yes"
225} 339}
226 340
227# Internal function to run an autotools' tool 341# Internal function to run an autotools' tool
342autotools_env_setup() {
343 # We do the "latest" → version switch here because it solves
344 # possible order problems, see bug #270010 as an example.
345 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
346 local pv
347 for pv in ${_LATEST_AUTOMAKE[@]/#*:} ; do
348 # has_version respects ROOT, but in this case, we don't want it to,
349 # thus "ROOT=/" prefix:
350 ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="${pv}"
351 done
352 [[ ${WANT_AUTOMAKE} == "latest" ]] && \
353 die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}"
354 fi
355 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
356}
228autotools_run_tool() { 357autotools_run_tool() {
358 # Process our own internal flags first
359 local autofail=true m4flags=false
360 while [[ -n $1 ]] ; do
361 case $1 in
362 --at-no-fail) autofail=false;;
363 --at-m4flags) m4flags=true;;
364 # whatever is left goes to the actual tool
365 *) break;;
366 esac
367 shift
368 done
369
370 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
371 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase"
372 fi
373
374 autotools_env_setup
375
229 local STDERR_TARGET="${T}/$$.out" 376 local STDERR_TARGET="${T}/$1.out"
377 # most of the time, there will only be one run, but if there are
378 # more, make sure we get unique log filenames
379 if [[ -e ${STDERR_TARGET} ]] ; then
230 local ris 380 local i=1
381 while :; do
382 STDERR_TARGET="${T}/$1-${i}.out"
383 [[ -e ${STDERR_TARGET} ]] || break
384 : $(( i++ ))
385 done
386 fi
231 387
232 echo "***** $1 *****" > ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 388 if ${m4flags} ; then
233 echo >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 389 set -- "${1}" $(autotools_m4dir_include) "${@:2}" $(autotools_m4sysdir_include)
390 fi
391
392 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}"
234 393
235 ebegin "Running $@" 394 ebegin "Running $@"
236 $@ >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 2>&1 395 "$@" >> "${STDERR_TARGET}" 2>&1
237 ris=$? 396 if ! eend $? && ${autofail} ; then
238 eend ${ris}
239
240 if [[ ${ris} != 0 && ${NO_FAIL} != 1 ]]; then
241 echo 397 echo
242 eerror "Failed Running $1 !" 398 eerror "Failed Running $1 !"
243 eerror 399 eerror
244 eerror "Include in your bugreport the contents of:" 400 eerror "Include in your bugreport the contents of:"
245 eerror 401 eerror
246 eerror " ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}" 402 eerror " ${STDERR_TARGET}"
247 echo 403 echo
248 die "Failed Running $1 !" 404 die "Failed Running $1 !"
249 fi 405 fi
250} 406}
251 407
252# Internal function to check for support 408# Internal function to check for support
253autotools_check_macro() { 409autotools_check_macro() {
254 [[ -f configure.ac || -f configure.in ]] && \ 410 [[ -f configure.ac || -f configure.in ]] || return 0
255 WANT_AUTOCONF="2.5" autoconf --trace=$1 2>/dev/null 411 local macro
412 for macro ; do
413 WANT_AUTOCONF="2.5" autoconf $(autotools_m4dir_include) --trace="${macro}" 2>/dev/null
414 done
256 return 0 415 return 0
257} 416}
258 417
418# Internal function to look for a macro and extract its value
419autotools_check_macro_val() {
420 local macro=$1 scan_out
421
422 autotools_check_macro "${macro}" | \
423 gawk -v macro="${macro}" \
424 '($0 !~ /^[[:space:]]*(#|dnl)/) {
425 if (match($0, macro ":(.*)$", res))
426 print res[1]
427 }' | uniq
428
429 return 0
430}
431
259# Internal function to get additional subdirs to configure 432# Internal function to get additional subdirs to configure
260autotools_get_subdirs() { 433autotools_get_subdirs() { autotools_check_macro_val AC_CONFIG_SUBDIRS ; }
261 local subdirs_scan_out 434autotools_get_auxdir() { autotools_check_macro_val AC_CONFIG_AUX_DIR ; }
435autotools_get_macrodir() { autotools_check_macro_val AC_CONFIG_MACRO_DIR ; }
262 436
263 subdirs_scan_out=$(autotools_check_macro "AC_CONFIG_SUBDIRS") 437_autotools_m4dir_include() {
264 [[ -n ${subdirs_scan_out} ]] || return 0 438 local x include_opts
265 439
266 echo "${subdirs_scan_out}" | gawk \ 440 for x in "$@" ; do
267 '($0 !~ /^[[:space:]]*(#|dnl)/) { 441 case ${x} in
268 if (match($0, /AC_CONFIG_SUBDIRS:(.*)$/, res)) 442 # We handle it below
269 print res[1] 443 -I) ;;
270 }' | uniq 444 *)
445 [[ ! -d ${x} ]] && ewarn "autotools.eclass: '${x}' does not exist"
446 include_opts+=" -I ${x}"
447 ;;
448 esac
449 done
271 450
272 return 0 451 echo ${include_opts}
273} 452}
453autotools_m4dir_include() { _autotools_m4dir_include ${AT_M4DIR} ; }
454autotools_m4sysdir_include() { _autotools_m4dir_include $(eval echo ${AT_SYS_M4DIR}) ; }
274 455
275autotools_get_auxdir() { 456fi
276 local auxdir_scan_out
277
278 auxdir_scan_out=$(autotools_check_macro "AC_CONFIG_AUX_DIR")
279 [[ -n ${auxdir_scan_out} ]] || return 0
280
281 echo ${auxdir_scan_out} | gawk \
282 '($0 !~ /^[[:space:]]*(#|dnl)/) {
283 if (match($0, /AC_CONFIG_AUX_DIR:(.*)$/, res))
284 print res[1]
285 }' | uniq
286
287 return 0
288}

Legend:
Removed from v.1.61  
changed lines
  Added in v.1.132

  ViewVC Help
Powered by ViewVC 1.1.20